//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MeasurementsUnit.h"
#include "display\ValueStringFormatter.h"
#include "device\Data.h"
#include "Utilities.h"
#include <time.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMeasurements *frmMeasurements;
//---------------------------------------------------------------------------
__fastcall TfrmMeasurements::TfrmMeasurements(TComponent* Owner)
	: TfrmCommon(Owner)
{
}
//---------------------------------------------------------------------------

void TfrmMeasurements::Process(const Data &data, int channel)
{
	if (const_cast<Data&>(data).getChannel(channel).dataOsc.empty())
		return;
	/** \todo spectrum, osc -> dataOsc, recorder -> dataRec? */
	AnsiString title = _("Ch. %s stats");
	this->Caption.sprintf(title.c_str(), GetChannelName(channel).c_str());
	measurements.Process(data, channel);

	char szTime[64] = {0};
	AnsiString asTime;
	if (strftime(szTime, sizeof(szTime), "%T", localtime(&data.timestamp.time)) > 0)
	{
		asTime.sprintf("%s.%03u", szTime, data.timestamp.millitm);
	}
	lblTimestampVal->Caption = asTime;

	lblValMin->Caption = ValueStringFormatter::VoltageToStr(measurements.fMin, 3).c_str();
	lblValMax->Caption = ValueStringFormatter::VoltageToStr(measurements.fMax, 3).c_str();
	lblValPp->Caption = ValueStringFormatter::VoltageToStr(measurements.fMax-measurements.fMin, 3).c_str();
	lblValAvg->Caption = ValueStringFormatter::VoltageToStr(measurements.fAvg, 3).c_str();
	lblValRms->Caption = ValueStringFormatter::VoltageToStr(measurements.fRms, 3).c_str();
	if (measurements.bFreqValid)
		lblFreqVal->Caption = ValueStringFormatter::FreqToStr(measurements.fFreq, 3).c_str();
	else
		lblFreqVal->Caption = "----";
}

